# Install environment for CPU part

Create a  python virtual environment, here with conda

```console
conda create --name jax_pip python=3.11 -y
conda activate jax_pip
pip install -r requirement_CPU.txt
```

Git package and start Jupyter Lab

```console
git clone https://gitlab.in2p3.fr/alice.faure/gray-scott-python.git
jupyter-lab
```

# Install CuPy with Conda

**NOTE:**

You can replace `micromamba` with `conda` and vice versa, same CLI

## Create env CuPy line by line

You must be in CUDA environment correctly installed, for example the `nvcc` compiler must be available

```console
$ nvcc --version
nvcc: NVIDIA (R) Cuda compiler driver
Copyright (c) 2005-2023 NVIDIA Corporation
Built on Wed_Nov_22_10:17:15_PST_2023
Cuda compilation tools, release 12.3, V12.3.107
Build cuda_12.3.r12.3/compiler.33567101_0
```

Now you can create your conda env CuPy 

```console
micromamba create --name cupy_p12
micromamba activate cupy_p12
micromamba config append channels conda-forge
micromamba install python=3.12 -y
micromamba install cupy=13.1.0 -y
micromamba install matplotlib pytest scipy -y
pip install opencv-python ipython
```

To export your conda env

```console
micromamba env export > cupy_env.yml
```

## Create with cupy_env.yaml

Import conda env like this

```console
conda env create -n cupy_p12 --file cupy_env.yml
conda activate cupy_p12
```