**Table Of Contents**
___

[[_toc_]]
___

For Linux: explore MUST from your file browser

[Connexion SSH à un serveur](https://club1.fr/docs/fr/tutos/connexion-linux.html)

fill  `/lapp_data/formation/` in "dossier".

# Bench Gray-Scott CPU, GPU

1920x1080 34x1000, generic stencil 3x3

* CPU JAX 1 CPU: 16s pour 100 images, => 160 s 
  *  taskset -c 0 python grayscott_jax_na.py

* GPU Cupy V100 env conda : 54 s
* GPU Cupy A100 env conda : 6 s

* GPU JAX V100 env conda : 22 s

# Compare laplacian method

Compare the 3 methods to compute the laplacian on GPU:
* with loop
* with unroll loop for 1,8,1 stencil
* with convol2d method

What difference compared to CPU ?

# Profiling memory transfert with perfetto

* use jax.profiler and perfetto GUI to edit result, [perfetto](https://jax.readthedocs.io/en/latest/profiling.html)
* As for cupy version profile, test 2 versions to tranfer image:
  * after 34 iterations
  * at the end

# Test JAX Gray-Scott for 2 GPUS

* A100
* V100

[MUST GPU doc](https://doc.must-datacentre.fr/batch/gpu/)

What is the performance ratio obtained ?

Find the explanation here.

[A100 versus V100](https://www.cudocompute.com/blog/nvidia-a100-vs-v100-how-do-they-compare?utm_source=google&utm_medium=cpc&utm_campaign=PMax&utm_term=&gad_source=1&gclid=EAIaIQobChMI4ce_4sWUhwMVKAsGAB1ltQ9wEAMYASAAEgJgzPD_BwE)

# Laplacian for generic stencil 3x3 unroll

```python
@jax.jit
def laplacian_9_pad(u, stcl):
    # padding 1 pixel arround
    upad = jnp.zeros(tuple(np.array(u.shape) + 2), dtype=np.float32)
    upad = upad.at[1:-1, 1:-1].set(u)
    lap = stcl[0,1]*upad.at[] ...
   ...
```

 * Check result with other implementation
 * Bench with 34x1000
 